
Redmine - Defect #20018

Duplicate activities in time entry report when project-specific activies exist

2015-06-04 15:04 - Stephane Evr

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Time tracking Estimated time: 0.00 hour

Target version: 4.2.4   

Resolution: Fixed Affected version: 3.2.2

Description

When using the report tool by Activity, it appears that some activities are repeated in the list, instead of being aggregated. The

activities concerned are all used in several projects.

Example:

Observed:

Activity    Total

X            3

X            4

Y            5

Y            6

Z            7

 

Expected:

Activity    Total

X            7

Y            11

Z            7

 If we apply the filter by projects, then by activities, there are no duplicates, everything works fine:

Project Activity   Total

1       X          3

1       Y          5

2       X          4

2       Y          6

2       Z          7

Related issues:

Related to Redmine - Defect #21056: Project specific TimeEntryActivity name n... Closed

Associated revisions

Revision 21371 - 2022-01-19 14:33 - Go MAEDA

Duplicate activities in time entry report when project-specific activies exist (#20018).

Patch by Yuichi HARADA.

Revision 21388 - 2022-01-29 07:19 - Go MAEDA

Merged r21371 from trunk to 4.2-stable (#20018).

History

#1 - 2015-07-02 10:40 - Toshi MARUYAMA

- Status changed from New to Needs feedback

Do you mean time time entry report?

And give us more information: Submissions.
https://www.redmine.org/projects/redmine/wiki/Submissions


#2 - 2015-07-02 13:30 - Stephane Evr

Yes, I mean the time entry report in general, not for a particular project.

Environment:

  Redmine version                3.0.1.stable.14155

  Ruby version                   2.2.1-p85 (2015-02-26) [x86_64-linux]

  Rails version                  4.2.1

  Environment                    production

  Database adapter               Mysql2

SCM:

  Subversion                     1.8.8

  Git                            1.9.1

  Filesystem                     

 here is an extract of my database for enumerations. I found several entries for the same name, which are linked to different projects:

mysql> select * from enumerations order by name;

+-----+-------------------------------+----------+------------+-------------------+--------+------------+-----

------+---------------+

| id  | name                          | position | is_default | type              | active | project_id | pare

nt_id | position_name |

+-----+-------------------------------+----------+------------+-------------------+--------+------------+-----

------+---------------+

|  11 | Specification                 |       13 |          0 | TimeEntryActivity |      1 |       NULL |     

 NULL | NULL          |

|  22 | Specification                 |       11 |          0 | TimeEntryActivity |      0 |          7 |     

   11 | NULL          |

|  94 | Specification                 |       62 |          0 | TimeEntryActivity |      0 |         39 |     

   11 | NULL          |

| 123 | Specification                 |       85 |          0 | TimeEntryActivity |      0 |         38 |     

   11 | NULL          |

| 129 | Specification                 |       89 |          0 | TimeEntryActivity |      0 |         42 |     

   11 | NULL          |

| 165 | Specification                 |      119 |          0 | TimeEntryActivity |      0 |         43 |     

   11 | NULL          |

|  19 | Training                      |       10 |          0 | TimeEntryActivity |      1 |       NULL |     

 NULL | NULL          |

| 204 | Training                      |      150 |          0 | TimeEntryActivity |      0 |         54 |     

   19 | NULL          |

| 221 | Training                      |      166 |          0 | TimeEntryActivity |      0 |         53 |     

   19 | NULL          |

| 238 | Training                      |      182 |          0 | TimeEntryActivity |      0 |         55 |     

   19 | NULL          |

#3 - 2015-07-09 10:36 - Stephane Evr

- File report_activities.PNG added

- File report_activities_projects.PNG added

Here is what I get for an activity called "Other":

 report_activities.PNG 

Now, If I add the "Projects" column (Each line is a different project):

 report_activities_projects.PNG 

#4 - 2015-07-30 15:17 - Toshi MARUYAMA

- Category set to Time tracking

- Status changed from Needs feedback to New

#5 - 2016-04-14 08:09 - Toshi MARUYAMA

#21056#note-8 :

Is a consequence of this issue

 See Submissions and give us what plugins you uses.

#6 - 2016-04-14 12:08 - Stephane Evr
- File 1.PNG added

- File 2.PNG added

- File 4.PNG added

- File 3.PNG added

- File 5.PNG added

- File 6.PNG added

- File 7.PNG added

- File 8.PNG added

Toshi MARUYAMA wrote:

#21056#note-8 :

Is a consequence of this issue

 See Submissions and give us what plugins you uses.

 Could reproduce the bug as described on a freshly launched Bitnami redmine demo instance (https://bitnami.com/launch/redmine/aws/now):

Environment:

  Redmine version                3.2.1.stable

  Ruby version                   2.1.8-p440 (2015-12-16) [x86_64-linux]

  Rails version                  4.2.5.2

  Environment                    production

  Database adapter               Mysql2

SCM:

  Subversion                     1.8.13

  Cvs                            1.12.13

  Git                            2.6.1

  Filesystem                     

Redmine plugins:

  no plugin installed

 Steps to follow using a fresh redmine install:

Create a new activity, do not check "Active":

 1.PNG 

Create two projects "Test A" and "Test B". Don't need to set any specific param, appart from the "Activities (Time tracking)" tab. Do as follows for

each project, then save:

 2.PNG 

Now that the activities are activated, time to log some time on each project:

 3.PNG 

and

 4.PNG 

Then click 1, then 2 on following:

 5.PNG 

Then click on the "Report" Button

 6.PNG 

Then click "Activity" in the Add section:

 7.PNG 

Result:

 8.PNG 

I hope these instructions are clear enough to be reproduced :)

#7 - 2016-05-13 14:17 - Toshi MARUYAMA

- Related to Defect #21056: Project specific TimeEntryActivity name not updating properly added

#8 - 2016-05-13 14:19 - Toshi MARUYAMA

- Subject changed from Duplicate activities in time entry report to Duplicate activities in time entry report of project specific TimeEntryActivity
- Status changed from New to Confirmed

- Affected version changed from 3.0.1 to 3.2.2

#9 - 2016-05-13 14:38 - Toshi MARUYAMA

mysql> select * from enumerations where name = "test0003";

+----+----------+----------+------------+-------------------+--------+------------+-----------+---------------

+

| id | name     | position | is_default | type              | active | project_id | parent_id | position_name 

|

+----+----------+----------+------------+-------------------+--------+------------+-----------+---------------

+

| 33 | test0003 |        6 |          0 | TimeEntryActivity |      0 |       NULL |      NULL | NULL          

|

| 41 | test0003 |        6 |          0 | TimeEntryActivity |      1 |          1 |        33 | NULL          

|

| 45 | test0003 |        6 |          0 | TimeEntryActivity |      1 |          2 |        33 | NULL          

|

+----+----------+----------+------------+-------------------+--------+------------+-----------+---------------

+

3 rows in set (0.00 sec)

#10 - 2017-05-30 11:48 - Stephane Evr

up

This still happens on Redmine 3.3.0.stable

#11 - 2021-12-06 06:47 - Yuichi HARADA

- File 20018.patch added

I also confirmed(trunk: r21299). I think the following patch will solve it.

diff --git a/lib/redmine/helpers/time_report.rb b/lib/redmine/helpers/time_report.rb

index 89b94ec3c4..1cf4604438 100644

--- a/lib/redmine/helpers/time_report.rb

+++ b/lib/redmine/helpers/time_report.rb

@@ -122,7 +122,7 @@ module Redmine

           'tracker' => {:sql => "#{Issue.table_name}.tracker_id",

                         :klass => Tracker,

                         :label => :label_tracker},

-          'activity' => {:sql => "#{TimeEntry.table_name}.activity_id",

+          'activity' => {:sql => "COALESCE(#{TimeEntryActivity.table_name}.parent_id, #{TimeEntryActivity.tab

le_name}.id)",

                          :klass => TimeEntryActivity,

                          :label => :field_activity},

           'issue' => {:sql => "#{TimeEntry.table_name}.issue_id",

#12 - 2021-12-19 08:33 - Go MAEDA

- Target version set to Candidate for next minor release

#13 - 2021-12-30 10:04 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.2.4

Setting the target version to 4.2.4.

#14 - 2022-01-19 14:34 - Go MAEDA

- Subject changed from Duplicate activities in time entry report of project specific TimeEntryActivity to Duplicate activities in time entry report when

project-specific activies exist

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

#15 - 2022-01-29 07:19 - Go MAEDA
https://www.redmine.org/projects/redmine/repository/svn/revisions/21299


- Status changed from Resolved to Closed

Files

report_activities.PNG 21 KB 2015-07-09 Stephane Evr

report_activities_projects.PNG 27.3 KB 2015-07-09 Stephane Evr

1.PNG 7.74 KB 2016-04-14 Stephane Evr

2.PNG 16.2 KB 2016-04-14 Stephane Evr

3.PNG 11.9 KB 2016-04-14 Stephane Evr

4.PNG 11.9 KB 2016-04-14 Stephane Evr

5.PNG 10.9 KB 2016-04-14 Stephane Evr

6.PNG 26.1 KB 2016-04-14 Stephane Evr

7.PNG 17.5 KB 2016-04-14 Stephane Evr

8.PNG 24.9 KB 2016-04-14 Stephane Evr

20018.patch 1.76 KB 2021-12-06 Yuichi HARADA
